# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-List-SomeUtils-XS
Version:	0.58
Release:	1.%{__distinit}%{__distvers}
Summary:	XS implementation for List::SomeUtils
License:	Artistic 2.0 and (GPL+ or Artistic)
URL:		https://metacpan.org/release/List-SomeUtils-XS
Source0:	https://cpan.metacpan.org/authors/id/D/DR/DROLSKY/List-SomeUtils-XS-%{version}.tar.gz
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(:VERSION) >= 5.12
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Run-time
BuildRequires:	perl(List::SomeUtils::PP)
BuildRequires:	perl(XSLoader)
# Tests
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Config)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(lib)
BuildRequires:	perl(List::SomeUtils)
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Storable)
BuildRequires:	perl(Test::Builder::Module)
BuildRequires:	perl(Test::LeakTrace)
BuildRequires:	perl(Tie::Array)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(Test::Warnings) >= 0.006
# Optional Tests
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(CPAN::Meta::Prereqs)
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(List::SomeUtils::PP)
Requires:	perl(XSLoader)

# Avoid provides for private shared objects
%{?perl_default_filter}

%description
List::SomeUtils provides some trivial but commonly needed functionality on
lists which is not going to go into List::Util.

XS implementation is faster than List::SomeUtils.

%prep
%setup -q -n List-SomeUtils-XS-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes CONTRIBUTING.md README.md
%{perl_vendorarch}/auto/List/
%{perl_vendorarch}/List/
%{_mandir}/man3/List::SomeUtils::XS.3*

%changelog
* Mon Jun 11 2018 Paul Howarth <paul@city-fan.org> - 0.58-1
- Update to 0.58
  - Re-release to fix the generated Makefile.PL
    We do not want to try to build the XS code with compiler warnings enabled
    except on Perl 5.24+ as there are unavoidable warnings with older Perls;
    if you tried to install this distro in an environment where AUTHOR_TESTING
    was set, these warnings would be enabled, along with "-Werror", causing the
    build to fail completely (GH#3)

* Tue May 29 2018 Paul Howarth <paul@city-fan.org> - 0.57-1
- Update to 0.57
  - Fix C compiler warnings (GH#2)
- Switch upstream from search.cpan.org to metacpan.org

* Wed Dec 13 2017 Paul Howarth <paul@city-fan.org> - 0.56-1
- Update to 0.56
  - The one() sub returned true when given an empty list, but it should return
    false (GH#3)

* Mon Jul 24 2017 Paul Howarth <paul@city-fan.org> - 0.55-1
- Update to 0.55
  - Added a new function, mode() (GH#2)
  - Skip all the tests unless List::SomeUtils 0.56 is installed; this fixes the
    issue where trying to install the new List::SomeUtils ends up pulling this
    distribution, which then fails because an older LSU is installed but
    doesn't export mode() (GH#1)
- BR: perl-interpreter rather than just perl
- BR: perl-generators unconditionally

* Fri Jun  2 2017 Paul Howarth <paul@city-fan.org> - 0.53-1
- Update to 0.53
  - Moved issue tracking to GitHub

* Wed Jun 29 2016 Paul Howarth <paul@city-fan.org> - 0.52-3
- Import from Fedora

* Sun May 15 2016 Jitka Plesnikova <jplesnik@redhat.com> - 0.52-2
- Perl 5.24 rebuild

* Mon May 09 2016 Jitka Plesnikova <jplesnik@redhat.com> - 0.52-1
- 0.52 bump

* Tue Mar 29 2016 Jitka Plesnikova <jplesnik@redhat.com> - 0.51-2
- Updated license and description

* Thu Mar 10 2016 Jitka Plesnikova <jplesnik@redhat.com> - 0.51-1
- Initial release
